﻿//DESCRIPTION: Pseudo Bottom align text frame(s)

if (app.documents.length == 0 || app.selection.length == 0) { exit() }
processSelection(app.selection);

function processSelection(sel) {
if (sel.length > 1) {
processMultiSelection(sel);
} else {
vjbottomTextFrame(locateTF(sel[0]));
}

function processMultiSelection(sel) {
for (var j = sel.length - 1; j >= 0; j--) {
if (sel[j].constructor.name == "TextFrame") {
vjbottomTextFrame(sel[j]);
}
}
}

function vjbottomTextFrame(tf) {
if (tf.textFramePreferences.textColumnCount > 1) {
// alert("Multi-column text frames not supported");
return
}
//save users measurement preferences
var userVert =  app.documents[0].viewPreferences.verticalMeasurementUnits;
app.documents[0].viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
var frameBottom = getFrameBottom(tf);
tf.textFramePreferences.minimumFirstBaselineOffset = 0;
var lastChar = tf.texts[0].characters[-1].index;
var textBottom = getTextBottom(tf);
var error = frameBottom - textBottom;
tf.textFramePreferences.minimumFirstBaselineOffset += error;

while (lastChar - tf.texts[0].characters[-1].index > tf.texts[0].lines[-1].length) {
tf.textFramePreferences.minimumFirstBaselineOffset -= getLeading(tf.texts[0].lines[-1]);
}
while (lastChar > tf.texts[0].characters[-1].index) {
tf.textFramePreferences.minimumFirstBaselineOffset -= getLeading(tf.texts[0].lines[-1])/4;
}
while (tf.texts[0].characters[-1].index >= lastChar) {
tf.textFramePreferences.minimumFirstBaselineOffset += getLeading(tf.texts[0].lines[-1])/16;
}
while (lastChar > tf.texts[0].characters[-1].index) {
tf.textFramePreferences.minimumFirstBaselineOffset -= getLeading(tf.texts[0].lines[-1])/64;
}
while (tf.texts[0].characters[-1].index >= lastChar) {
tf.textFramePreferences.minimumFirstBaselineOffset += getLeading(tf.texts[0].lines[-1])/256;
}
while (lastChar > tf.texts[0].characters[-1].index) {
tf.textFramePreferences.minimumFirstBaselineOffset -= getLeading(tf.texts[0].lines[-1])/1024;
}
app.documents[0].viewPreferences.verticalMeasurementUnits = userVert;
}

function getLeading(text) {
if (text.leading == Leading.auto) {
return text.pointSize * text.autoLeading/100;
} else {
return text.leading
}
}

function oscillating(err, olderr) {
if (Math.abs(olderr) > Math.abs(err)) { return false }
if (err * olderr >= 0)  { return false }
return true
}

function getTextBottom(tf) {
var botline = tf.texts[0].lines[-1];
var bottom = botline.baseline;
return bottom;
}

function getFrameBottom(tf) {
var aBounds = tf.geometricBounds;
return aBounds[2]
}

function locateTF(obj) {
if (obj.constructor.name == "TextFrame") { return obj }
try {
return obj.parentTextFrames[0];
} catch (e) {
alert("Can't locate text frame from selection.");
}
}
}